var consoleListener = {
	observe:		function(aMessageObject) {
						this.getMessage(aMessageObject);
    				},
				    
	getMessage:		function(aMessageObject) {
						var hideChromeErrors	= JSCOConstants.JSCOPREF.getBoolPref("hideChromeErrors");
						var dateTimeString		= JSCOUtils.getDateTime();
		
						// Try to QI it to a script error to get more info
						try {
							var scriptError		= aMessageObject.QueryInterface(Components.interfaces.nsIScriptError);
							var nsIScriptError	= Components.interfaces.nsIScriptError;
							
							/* We can choose to hide chrome errors */
							if (scriptError.sourceName.substr(0, 9) == "chrome://" && hideChromeErrors) return;
	
							/* Is this error actually just a non-fatal warning? */
							var warning = scriptError.flags & nsIScriptError.warningFlag != 0;

							var messageType = warning ? "Warning" : "Error";
							var messageText = scriptError.message;
	
	
							/* I don't really know if this kind of exception
							 * can be intercepted other than with a RegExp
							 * (and an ugly RegExp, at that)
							 */
							if(messageText.substr(0,18)=="uncaught exception") {
								var exceptionRE = new RegExp("\\[(\\w+\\.\\w+)(?:.)+? nsresult: \".+?\\(((?:.)+?)\\)\"  location: \".+? :: ((?:.)+?) :: (.(?:.)+?) :: line (\\d)\"");
								var arrStrings = exceptionRE.exec(messageText);

								messageText	= arrStrings[2] + ": " + arrStrings[1];
								var messageURL	= arrStrings[3];
								var messageLine = arrStrings[5];
								var messageCode = arrStrings[4];
							} else {
								if (scriptError.lineNumber || scriptError.sourceName) {
									var messageURL	= scriptError.sourceName;
									var messageLine	= scriptError.lineNumber;
								}
		
								if (scriptError.sourceLine) {
									var messageCode = scriptError.sourceLine;
									if (scriptError.columnNumber) var messageCol = scriptError.columnNumber;
								}
							}
							
							JSConsoleOutput.writeToFile(dateTimeString + messageType + "\t(line " + messageLine + ")\tin " + messageURL + ": " + messageText + (messageCode!=undefined?"\n\t\t" + messageCode:"") + "\n");
						} catch (ex) {
							try {
								// Try to QI it to a console message
								var consoleMessage = aMessageObject.QueryInterface(Components.interfaces.nsIConsoleMessage);

								/* This ensure us to avoid printing
								 * an empty line when the console is cleared
								 */
								if(consoleMessage.message!="") {
									JSConsoleOutput.writeToFile(dateTimeString + " " + consoleMessage.message + "\n");
								}
							} catch (ex2) {
								// Give up and append the object itself as a string
								JSConsoleOutput.writeToFile(dateTimeString + " " + aMessageObject + "\n");
							}
						}
					}
};
